﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace PizzaMaker {
    public abstract class Pizza {
        public void Prepare() {
            PrepareDough();
            AddSauce();
            AddAdditions();
            AddSpices();
            Bake();
        }


        public void Bake() {
            Console.WriteLine("Wlączam pieczenie na " + GetBakingTime());
        }
        public virtual void AddSauce() {
            AddTomatoSauce();
        }

        public virtual string GetBakingTime(){
            return "15 minut";
        }

        public abstract void AddSpices();

        public abstract void AddAdditions();


        public abstract void PrepareDough();

        private void AddTomatoSauce() {
            Console.WriteLine("Dodaje sos pomidorowy...");
        }
    }
}
