﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace SymulatorKaczek_Podejście2
{
    interface ILatające
    {
        void Lec();
    }

    interface IKwaczące
    {
        void Kwacz();
    }

    abstract class Kaczka
    {
        public void Plywaj()
        {
            Console.WriteLine("Pływam!");
        }

        public abstract void Wyswietl();
    }

    class DzikaKaczka : Kaczka, ILatające, IKwaczące
    {
        public override void Wyswietl()
        {
            Console.WriteLine("Jestem dziką kaczką!");
        }

        public void Lec()
        {
            Console.WriteLine("Ja latam!");
        }

        public void Kwacz()
        {
            Console.WriteLine("Kwa! Kwa!");
        }
    }

    class GumowaKaczka : Kaczka, IKwaczące
    {
        public override void Wyswietl()
        {
            Console.WriteLine("Jestem gumową kaczką!");
        }

        public void Kwacz()
        {
            Console.WriteLine("Kwa! Kwa!");
        }
    }

    class WabikKaczka : Kaczka
    {
        public override void Wyswietl()
        {
            Console.WriteLine("Jestem wabikiem na kaczki!");
        }
    }

    class Program {
        static int Main(string[] args) {
            Kaczka dzika = new DzikaKaczka();
            dzika.Plywaj();
            IKwaczące dzikaKwacząca = dzika as IKwaczące;
            dzikaKwacząca.Kwacz();

            GumowaKaczka gumowa = new GumowaKaczka();
            gumowa.Kwacz();
            gumowa.Wyswietl();

            Console.ReadKey();
            return 0;
        }
    }
}
